OGRE-Next: Ogre::DDSCodec2 Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
Ogre::DDSCodec2 Class Reference
Core » Image

Codec specialized in loading DDS (Direct Draw Surface) images. More...

`#include <OgreDDSCodec2.h>`

Inheritance diagram for Ogre::DDSCodec2:
[legend]

## Public Member Functions
| DDSCodec2 ()
| ~DDSCodec2 () override
DecodeResult | decode (DataStreamPtr &input) const override
| Codes the data from the input chunk into the output chunk.
DataStreamPtr | encode (MemoryDataStreamPtr &input, CodecDataPtr &pData) const override
| Codes the data in the input stream and saves the result in the output stream.
void | encodeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const override
| Codes the data in the input chunk and saves the result in the output filename provided.
String | getType () const override
| Returns the type of the codec as a String.
String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const override
| Maps a magic number header to a file extension, if this codec recognises it.
ValidationStatus | validateMagicNumber (const char *magicNumberPtr, size_t maxbytes) const override
| validateMagicNumber Returns whether a magic number header matches this codec.
Public Member Functions inherited from Ogre::ImageCodec2
| ~ImageCodec2 () override
String | getDataType () const override
| Returns the type of the data that supported by this codec as a String.
Public Member Functions inherited from Ogre::Codec
virtual | ~Codec ()
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.

## Static Public Member Functions
static void | shutdown ()
| Static method to shutdown and unregister the DDS codec.
static void | startup ()
| Static method to startup and register the DDS codec.
Static Public Member Functions inherited from Ogre::Codec
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static CodecIterator | getCodecIterator ()
| Gets the iterator for the registered codecs.
static StringVector | getExtensions ()
| Gets the file extension list for the registered codecs.
static bool | isCodecRegistered (const String &codecType)
| Return whether a codec is registered already.
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unregisterCodec (Codec *pCodec)
| Unregisters a codec from the database.

## Additional Inherited Members
Public Types inherited from Ogre::Codec
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator< CodecList > | CodecIterator
typedef std::pair< MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.
enum | ValidationStatus { CodecValid , CodecInvalid , CodecUnknown }

## Detailed Description

Codec specialized in loading DDS (Direct Draw Surface) images.

Remarks
  We implement our own codec here since we need to be able to keep DXT data compressed if the card supports it.

## Constructor & Destructor Documentation

## ◆ DDSCodec2()

Ogre::DDSCodec2::DDSCodec2 | ( |  | ) |

## ◆ ~DDSCodec2()

Ogre::DDSCodec2::~DDSCodec2 | ( |  | ) |
| inlineoverride

## Member Function Documentation

## ◆ decode()

DecodeResult Ogre::DDSCodec2::decode | ( | DataStreamPtr & | input | ) | const
| overridevirtual

Codes the data from the input chunk into the output chunk.

Parameters

  input | Stream containing the encoded data

Implements Ogre::Codec.

## ◆ encode()

DataStreamPtr Ogre::DDSCodec2::encode | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData ) const
| overridevirtual

Codes the data in the input stream and saves the result in the output stream.

Implements Ogre::Codec.

## ◆ encodeToFile()

void Ogre::DDSCodec2::encodeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData ) const
| overridevirtual

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters

  input | The input data
  outFileName | The filename to write to
  pData | Extra information to be passed to the codec (codec type specific)

Implements Ogre::Codec.

## ◆ getType()

String Ogre::DDSCodec2::getType | ( |  | ) | const
| overridevirtual

Returns the type of the codec as a String.

Implements Ogre::Codec.

## ◆ magicNumberToFileExt()

String Ogre::DDSCodec2::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| overridevirtual

Maps a magic number header to a file extension, if this codec recognises it.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  A blank string if the magic number was unknown, or a file extension.

Implements Ogre::Codec.

## ◆ shutdown()

static void Ogre::DDSCodec2::shutdown | ( |  | ) |
| static

Static method to shutdown and unregister the DDS codec.

## ◆ startup()

static void Ogre::DDSCodec2::startup | ( |  | ) |
| static

Static method to startup and register the DDS codec.

## ◆ validateMagicNumber()

ValidationStatus Ogre::DDSCodec2::validateMagicNumber | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes ) const
| overridevirtual

validateMagicNumber Returns whether a magic number header matches this codec.

At least 4 bytes must be supplied.

Parameters

  magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  maxbytes | The number of bytes passed

Returns
  Validation status.

Implements Ogre::Codec.

The documentation for this class was generated from the following file:

- OgreDDSCodec2.h